/*
  Macro           RanGen
  Author          Carlo Hogeveen
  Website         eCarlo.nl/tse
  Compatibility   Windows TSE v4.41.37a upwards
  Version         v1   3 Apr 2023

  This tool generates a random string of letters, numbers or both,
  of a selectable length.

  You can copy the generated string from the result-prompt.


  HISTORY

  v1   3 Apr 2023
    Initial release.
*/



integer start_time = 0

string proc rangen(integer what, integer amount)
  integer char_code             = 0
  integer i                     = 0
  string  result [MAXSTRINGLEN] = ''
  do start_time - GetTime() times
    random()
  enddo
  start_time = GetTime()
  for i = 1 to amount
    case what
      when 1
        char_code = Asc('A') + random(0, 25)
      when 2
        char_code = Asc('0') + random(0, 9)
      otherwise
        char_code = Asc('0') + random(0, 35)
        if char_code > Asc('9')
          char_code = char_code + 7
        endif
    endcase
    result= result + Chr(char_code)
  endfor
  return(result)
end rangen

proc WhenLoaded()
  start_time = GetTime()
  do GetWinHandle() times
    random()
  enddo
end WhenLoaded

proc Main()
  integer amount                = 0
  string  amount_answer     [9] = ''
  string  result [MAXSTRINGLEN] = ''
  integer what                  = 0
  string  what_phrase      [23] = ''
  repeat
    if what > 1
      do what - 1 times
        PushKey(<Tab>)
      enddo
    endif
    what = MsgBoxEx('GenRan', 'Generate random what?',
                    '[&Letters];[&Digits];[&Both]')
    if what
      case what
        when 1
          what_phrase = 'characters'
        when 2
          what_phrase = 'digits'
        otherwise
          what_phrase = 'alphanumeric characters'
      endcase
      if Ask('How many ' + what_phrase + ' to generate?', amount_answer)
        amount  = Val(Trim(amount_answer))
        if amount
          result = rangen(what, amount)
          Ask('Result - You can copy it from here  ', result)
        endif
      else
        what = 0
      endif
    endif
  until not what
     or not amount
  PurgeMacro(SplitPath(CurrMacroFilename(), _NAME_))
end Main

